package Server_Client;
import java.io.*;
import java.net.ServerSocket;
import java.net.Socket;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.List;

public class Server {
    private File registeredList = createAFile();
    static ServerSocket serverSocket=null;

    public Server() throws IOException {
        runRegistration();
    }

    /**
     *
     * @return
     */
    public void runRegistration() {
        if (serverSocket!=null) return;
        try {
            serverSocket = new ServerSocket(5757);
            System.out.println("server connected");
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public boolean waitForClient() throws IOException {
        boolean s = false;
        while (true) {
            Socket connectionSocket = serverSocket.accept();
            System.out.println("new client connected");
            OutputStream out = connectionSocket.getOutputStream();
            InputStream in = connectionSocket.getInputStream();
            BufferedReader reader = new BufferedReader(new InputStreamReader(in));
            String line = reader.readLine();
            System.out.println(line.split("\\|")[0]);
            s = !pass_userNameIsAvailable(line.split("\\|")[0]);
            if (s) {
                String file = new String(Files.readAllBytes(Paths.get(registeredList.toURI())), StandardCharsets.UTF_8);
                FileOutputStream fileWriter = new FileOutputStream(registeredList);
                PrintStream ps =  new PrintStream(fileWriter);
                ps.println(file);
                ps.println(line);
            }
            break;
        }
        return s;
    }


    /**
     *
     * @param username
     * @return
     * @throws IOException
     */
    public boolean pass_userNameIsAvailable( String username) throws IOException {
        for (String line : readFile()){
            if (line.trim().isEmpty()) continue;
            System.out.println(line);
            if (line.split("\\|")[0].equalsIgnoreCase(username.trim())) return true;
        }
        return false;
    }

    public boolean pass_userNameIsAvailable( String pass,String username) throws IOException {
        for (String line : readFile()){
            if (line.split("\\|")[0].equalsIgnoreCase(username.trim()) &&
            line.split("\\|")[1].equals(pass.trim())) return true;
        }
        return false;
    }

    /**
     *
     * @return
     * @throws IOException
     */
    private List<String> readFile() throws IOException {
        return Files.readAllLines(Paths.get(registeredList.toURI()));
    }

    /**
     *
     * @return
     */
    public File createAFile() throws IOException {
        File registeredList = null;
        try {
             registeredList = new File("C:\\Users\\Lenovo\\IdeaProjects\\JTankTrouble\\src\\Server_Client\\registeredName\\registeredList");
            if (registeredList.createNewFile()) {
                System.out.println("File created: " + registeredList.getName());
            } else {
                System.out.println("File already exists.");
            }
        } catch (IOException e) {
            System.out.println("An error occurred.");
            e.printStackTrace();
        }
        return registeredList;
    }
}