package UI.GameState;


import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

public class BulletState  {

    public int locX, locY, diam , angle;
    private WallState wallState;
    private boolean keySpace;
    private KeyHandler2 keyHandler2 = new KeyHandler2();
    private long createTime;


    public BulletState(WallState wallState , TankState tankState){
        this.wallState = wallState ;
        // Initialize the game state and all elements ...
        locX = tankState.locX;
        locY = tankState.locY;
        angle = tankState.rotate;
        diam = 10;
        keySpace = false;
        tankState.getMyListener().add(keyHandler2);
        createTime = System.currentTimeMillis();
    }

    public void update(){
            if (wallState.getWallForBullet(locX , locY) != null) {
                int wallX = wallState.getWallForBullet(locX, locY).getX();
                int wallY = wallState.getWallForBullet(locX , locY).getY();
                int width = wallState.w;
                int high = wallState.h;
                if (wallState.getWallForBullet(locX, locY).isHorizontal()) {
                    if ((locX > wallX -10 && locX< wallX +10) || (locX < wallX + width +10 && locX> wallX + width -10)) angle = 180  - angle;
                     else angle = 360 - angle;
                    if (wallState.getWallForBullet(locX , locY).isDestructible()){
                        wallState.getWalls().remove(wallState.getWallForBullet(locX , locY));
                    }
                }
                else if (wallState.getWallForBullet(locX, locY).isVertical()) {
                    if ((locY > wallY + high -10 && locY< wallY +high +10) || (locY > wallY  -10 && locY< wallY  +10)) angle = 360  - angle;
                     else angle = 180  - angle;
                    if (wallState.getWallForBullet(locX , locY).isDestructible()){
                        wallState.getWalls().remove(wallState.getWallForBullet(locX , locY));
                    }
                }
            }
        locY += 10*Math.sin(Math.toRadians(angle) ) ;
        locX += 10*Math.cos(Math.toRadians(angle) ) ;
    }


    public long getCreateTime() {
        return createTime;
    }

    class KeyHandler2 extends KeyAdapter{
        @Override
        public void keyPressed(KeyEvent e){
            if (e.getKeyCode() == KeyEvent.VK_SPACE) {
                keySpace = true;
            }
        }

        @Override
        public void keyReleased(KeyEvent e){
            if (e.getKeyCode() == KeyEvent.VK_SPACE) {
                keySpace = false;
            }
        }

    }

}
