package UI.GameState;
/*** In The Name of Allah ***/


import UI.LogIn.Game.GameFrame;
import UI.LogIn.Game.MyListener;

import java.awt.event.KeyListener;
import java.util.ArrayList;
import java.util.Random;


/**
 * This class holds the state of the game and all of its elements.
 * This class also handles user inputs, which affect the game state.
 *
 * @author Seyede zahra seyed fatehi
 */
public class TankState {
    protected MyListener myListener = new MyListener();
    protected boolean keyUP, keyDOWN, keyRIGHT, keyLEFT, keySpace , keyS , keyD, keyF , keyE , keyQ;
    protected boolean mousePress;
    protected int mouseX, mouseY;
    public int locX, locY, diam, rotate;
    public boolean gameOver;
    protected WallState walls;
    protected ArrayList<BulletState> bullets = new ArrayList<>();
    private boolean hasShield;


    public TankState(WallState walls) {
        this.walls = walls;
        // Initialize the game state and all elements ...
      //  setFirstLocationOfTank();
      setFirstLocationOfTank();
        rotate = 0;
        diam = 32;
        keyUP = false;
        keyDOWN = false;
        keyRIGHT = false;
        keyLEFT = false;
        keySpace = false;
        keyS = false;
        keyD = false;
        keyE = false;
        keyF = false;
        keyQ = false;

        mousePress = false;
        mouseX = 0;
        mouseY = 0;

        gameOver = false;
    }

    private void setFirstLocationOfTank() {
        Random randomX = new Random();
        Random randomY = new Random();
        while (true) {
            locX = randomX.nextInt(GameFrame.GAME_WIDTH-20);
            locY = randomY.nextInt(GameFrame.GAME_HEIGHT-40);
            System.out.println(locX +"   "+locY);
            if (!walls.isWallForTank(locX , locY) && locX > 10 && locY >10 && locX < GameFrame.GAME_WIDTH-10 && locY < GameFrame.GAME_HEIGHT -10)
                break;
        }
    }



    public WallState getWalls() {
        return walls;
    }

    public ArrayList<BulletState> getBullets() {
        return bullets;
    }

    public MyListener getMyListener() {
        return myListener;
    }

    /**
     * The method which updates the game state.
     */
    public void update() {
        //
        // Update the state of all game elements
        //  based on user input and elapsed time ...
        //

        int lastx = locX,lasty = locY,lastr = rotate;

        if (mousePress) {
            locY = mouseY - diam / 2;
            locX = mouseX - diam / 2;
        }
        if (keyUP || keyE) {
            if (rotate == 0)
                rotate = 360;
            locY -= 8;
            if ((rotate > 180 && rotate < 270)|| rotate ==180 )
                rotate +=10;
            else if ( (rotate > 270 && rotate < 360) || rotate == 360)
                rotate -=10;

            else
                rotate =270;
        }
        if (keyDOWN || keyD) {
            rotate = rotate % 360;
            locY += 8;
            if ( (rotate  > 0 && rotate < 90 )|| rotate == 0)
                rotate +=10;
            else if ( (rotate > 90 && rotate <180 )|| rotate == 180 )
                rotate -=10;
            else
                rotate = 90;
        }
        if (keyLEFT || keyS ){
            rotate = rotate % 360;
            locX -= 8;
            if ( (rotate> 90 && rotate <180) || rotate== 90 )
                rotate +=10;
            else if ( (rotate >180 && rotate < 270) || rotate ==270 )
                rotate -=10;
            else
                rotate =180;
        }
        if (keyRIGHT || keyF) {
            rotate = rotate % 360;
            locX += 8;
            if ( (rotate > 270 && rotate < 360) || rotate ==270 )
                rotate +=10;
            else if ( (rotate < 90 && rotate > 0) || rotate == 90 )
                rotate -=10;
            else
                rotate = 0;
        }
        if (keySpace || keyQ){
            if (bullets.size() == 0 || System.currentTimeMillis() -bullets.get(bullets.size()-1).getCreateTime()>500 ) {
                BulletState newBullet = new BulletState(walls, this);
                bullets.add(newBullet);
            }
        }


        if (walls.isWallForTank(locX,locY)){
            locX = lastx;
            locY = lasty;
        }

        locX = Math.max(locX, 0);
        locX = Math.min(locX, GameFrame.GAME_WIDTH - diam);
        locY = Math.max(locY, 0);
        locY = Math.min(locY, GameFrame.GAME_HEIGHT - diam);

    }

    public boolean hasShield() {
        return hasShield;
    }

    public void setHasShield(boolean hasShield) {
        this.hasShield = hasShield;
    }
}

