package UI.Registration;

import Server_Client.Client;
import Server_Client.Server;
import UI.LogIn.MainFrame;

import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.IOException;
public class InitialPanel extends JPanel {
    public static boolean clickOnPlay;
    private JTextField userName = new JTextField();
    private JTextField pass = new JTextField();

    public InitialPanel(){
        clickOnPlay = false;
        initComponents();
        setPreferredSize(new Dimension(50 , 100));
        setSize(50 , 100);
    }

    public boolean isClickOnPlay() {
        return clickOnPlay;
    }

    public void initComponents(){
        JTextField gottenSecretCode = new JTextField();
        gottenSecretCode.setPreferredSize(new Dimension(gottenSecretCode.getWidth()+200 , gottenSecretCode.getHeight()+30));
        JButton logInBtn = new JButton("log in");
        JButton regBtn = new JButton("sign up");
        logInBtn.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                super.mouseClicked(e);
                try {
                    Server server = new Server();
                    if (server.pass_userNameIsAvailable( pass.getText() , userName.getText())){
                        MainFrame mainframe = new MainFrame("Trouble Tank");
                    }
                    else {
                        JOptionPane.showMessageDialog(logInBtn,"error");
                    }
                } catch (IOException ex) {
                    ex.printStackTrace();
                }
            }
        });

        regBtn.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                super.mouseClicked(e);
                JFrame registration =  new JFrame();
                registration.setSize(200 , 200);
                registration.setLocation(500 , 300);
                registration.setResizable(true);
                registration.add(setRegistrationPanel());
                registration.revalidate();
                registration.repaint();
                registration.setVisible(true);
            }
        });

        this.setLayout(new GridLayout(4,1));
        add(setUserNamePanel());
        add(setPassPanel());
        add(logInBtn);
        add(regBtn);
    }

    private JPanel setUserNamePanel(){
        JPanel userNamePanel = new JPanel();
        JLabel label = new JLabel("user name");
        userName.setPreferredSize(new Dimension(userName.getWidth() + 200,userName.getHeight()+ 30));
        userNamePanel.add(label);
        userNamePanel.add(userName);
        return userNamePanel;
    }

    private JPanel setPassPanel(){
        JPanel passPanel = new JPanel();
        JLabel label = new JLabel("password");
        pass.setPreferredSize(new Dimension(pass.getWidth() + 200,pass.getHeight()+ 30));
        passPanel.add(label);
        passPanel.add(pass);
        return passPanel;
    }

    private JPanel setRegistrationPanel(){
        JPanel regPanel = new JPanel();
        JPanel fieldsPanel = new JPanel(new GridLayout(4,2));
        JLabel username= new JLabel("username");
        JTextField usernameField= new JTextField();
        JLabel password = new JLabel("password");
        JTextField passwordField = new JTextField();
        JLabel passwordRp = new JLabel("passwordRp");
        JTextField passwordRepField = new JTextField();
        JLabel email = new JLabel("Email address");
        JTextField emailField = new JTextField("optional");
        JButton saveBtn = new JButton("sign up");
        fieldsPanel.add(username);
        fieldsPanel.add(usernameField);
        fieldsPanel.add(password);
        fieldsPanel.add(passwordField);
        fieldsPanel.add(passwordRp);
        fieldsPanel.add(passwordRepField);
        fieldsPanel.add(email);
        fieldsPanel.add(emailField);
        regPanel.add(fieldsPanel);
        regPanel.add(saveBtn);


        saveBtn.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                super.mouseClicked(e);
                if (usernameField.getText().equalsIgnoreCase("") || passwordField.getText().equals("") || passwordRepField.getText().equals("")){
                    JOptionPane.showMessageDialog(saveBtn,"you should fill blank fields.\n Email is not necessary.");
                }
                else if (passwordField.getText().equals(passwordRepField)){
                    JOptionPane.showMessageDialog(saveBtn,"password and repetition are not equal");
                }
                else {

                    try {
                        Server server = new Server();
                        System.out.println("loading");
                        Client newClient = new Client(usernameField.getText() , passwordField.getText() );
                        newClient.run();
                        boolean s = server.waitForClient();
                        if (s){
                            JOptionPane.showMessageDialog(saveBtn,"done");
                        }else{
                            JOptionPane.showMessageDialog(saveBtn,"username already exists");
                        }
                    } catch (IOException ex) {
                        ex.printStackTrace();
                    }

                }
            }
        });
        return regPanel;
    }
}
